{

Arbeitsauftrag:
---------------

- Fadeout
- Amplify
- Anwender-Desktop-Outfit


}
 PROGRAM Frankus_Disk_Writer_II;

uses fio,
     crt,
     fdwparam,
     fdw2_lch,
     fdw2_rch,
     fdwinput,
     dmfcheck,
     pattload,
     calc1,
     optimvol,
     blknfo_1,
     blknfo_2,
     dos,
     fdw_disp,
     stoppuhr;

procedure abbruch;
begin
cls;
writeln ('FDW2 aborted.');
halt(1);
end;

procedure check_freien_platz;
  var laufwerk: byte;
      laufwerkstr: string[2];
      wavdatasize: longint;
      freier_platz: real;
begin
  if dateiname[2][2] = ':' then
    laufwerk := ord(dateiname[2][1]) - 64
  else
    laufwerk := 0;
  laufwerkstr := dateiname[2][1]+dateiname[2][2];
  freier_platz := diskfree(laufwerk);
  if freier_platz < 0 then freier_platz := 4294967296.0 + freier_platz;
  wavdatasize := fit(dmf_dauer * mixfreq);
  if stereo then wavdatasize := wavdatasize * 2;
  if not _8bit then wavdatasize := wavdatasize * 2;
  inc(wavdatasize,44);
  if freier_platz < wavdatasize then
  begin
    beep;
      if not kein_batchbetrieb then abbruch;
      if kein_batchbetrieb then
      if not zustimmung('NOT ENOUGH FREE SPACE ON DRIVE '+laufwerkstr, 'Continue anyway?', FALSE)
      then abbruch;
  end;
  free_disk_space := freier_platz;
end;

procedure normal;
begin
  if existing (dateiname[2]) and kein_batchbetrieb then
    if not zustimmung('Datei "'+dateiname[2]+'" existiert bereits!', 'berschreiben?', FALSE)
    then abbruch;
  dmf_checken(dateiname[1]);
  get_pattmem;
  set_up_dmf(dateiname[1]);
  get_dauer;
  {close(inputdmf);}
{  writeln ('Dauer von ',dateiname[1],': ',dmf_dauer:0:2,' Sekunden.');
  writeln ('Grte Blocklnge: ', maxblocklen);
  writeln ('Blockanzahl: ', blockanz);}
  check_freien_platz;

  assign(outputfile, dateiname[2]);
  rewrite(outputfile, 1);
  blockwrite (outputfile, wav_header, 44);
  maxvolume := 1; { 1 ist wichtig, weil's sonst 'ne Division durch Null gibt! }
  reset_trackinfo;
  stoppuhr_reset;
  stoppuhr_start;
  berechnete_sekunden := 0;

  mask;

  for sequentry := 1 to sequenzerentries do
    calculate_pattern(sequenzer[sequentry]+1);

  stoppuhr_stop;
  round_up_wav;
  close(inputdmf);
{  for sequentry := 0 to blockcount do begin
    writeln (block_amplify(blockcount)); wait; end;}
  optimize_volume;

  close(outputfile);
end;

procedure services;
var checkstr: string[6];
    dwordbuf: longint;
    bytebuf: byte;
    elapsed_time: real;
    fremdfile: file;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
    old_filepos: longint;
    ver, vercheck: word;
label neuer_name, hey;

begin
  if continue_fdw then
  begin
(********* FDW - Datei laden *********)
  fdw_dateiname := dateiname[1];
  assign (outputfile, dateiname[1]);
  reset(outputfile, 1);
  blockread(outputfile, checkstr[0], 4);
  if not (checkstr[0]+checkstr[1]+checkstr[2]+checkstr[3] = 'FDWD')
  then begin
         beep;
         if kein_batchbetrieb then errmsg ('Error:', '"'+dateiname[1]+'" is not a valid FDW - file!');
         close(outputfile);
         abbruch
       end;

  blockread(outputfile, dwordbuf,4);
  seek(outputfile, dwordbuf);
  strbuf := 'DWDATA';
  strbuf[0] := 'F';
  blockread(outputfile, checkstr[0], 7);
  if not (checkstr[0]+checkstr[1]+checkstr[2]+checkstr[3]
         +checkstr[4]+checkstr[5]+checkstr[6] = 'FDWDATA')
  then begin
         beep;
         if kein_batchbetrieb then errmsg ('Error:', '"'+dateiname[1]+'" Error in FDW - file!');
         close(outputfile);
         abbruch
       end;
  vercheck := $0204;
  blockread(outputfile, ver, 2);
  if ver <> vercheck then begin
         beep;
         if kein_batchbetrieb then errmsg ('Error:', '"'+dateiname[1]+'" Incorrect FDW - Version!');
         close(outputfile);
         abbruch
       end;

  blockread(outputfile, optimize_already, 1);
  { FDW - Header ist fertig }

    blockread(outputfile, bytebuf, 1);
    blockread(outputfile, dateiname[1][1], bytebuf);
    dateiname[1][0] := chr(bytebuf);
    blockread(outputfile, bytebuf, 1);
    blockread(outputfile, dateiname[2][1], bytebuf);
    dateiname[2][0] := chr(bytebuf);
    old_filepos := filepos(outputfile);
    close(outputfile);
    { Dateinamen }
    if not existing (dateiname[1]) then begin
      beep;
      if kein_batchbetrieb then errmsg ('Error:', 'File "'+dateiname[1]+'" not found!');
      abbruch;
    end;

    neuer_name:;
    if existing(dateiname[2]) then
    begin
      beep;
      if zustimmung('File '+dateiname[2]+' is already existing', 'Overwrite?', false)
        then begin assign(fremdfile, dateiname[2]);erase(fremdfile) end
      else
        begin
          hey:;
          dateiname[2] := textinput('Please enter new name', 'Filename (.WAV):', 40);
          FSplit(dateiname[2], D, N, E);
          if N = '' then
          begin
             errmsg('Hey!', 'I said: PLEASE ENTER A NEW NAME!!!');
             goto hey;
          end;
          if E = '' then
          E := '.WAV';
          dateiname[2] := D + N + E;
          goto neuer_name;
        end;
    end;

    rename(outputfile, dateiname[2]);

    assign(outputfile, dateiname[2]);
    reset(outputfile, 1);
    seek(outputfile, old_filepos);



  if optimize_already then
  begin
  (*********** Lautstrke-Optimierung ********)
    stoppuhr_start;

    optimize_volume_from_FDW;

    stoppuhr_stop;
    round_up_wav;

    close(outputfile);

  (*********** Lautstrke-Optimierung ENDE ***)
  end
  else
  begin
  (*********** Berechnung weiterfhren *********)

    blockread(outputfile, maxblocklen, sizeof(maxblocklen));
    blockread(outputfile, blockanz, sizeof(blockanz));
    blockread(outputfile, dmf_dauer, sizeof(dmf_dauer));
    { Werte, die durch get_dauer ermittelt wurden }

    get_lchan_mem;
    get_rchan_mem;
    init_writebuffer;
    get_blocknfo1_mem;
    get_blocknfo2_mem;

    blockread(outputfile, maxvolume, sizeof(maxvolume));
    blockread(outputfile, startsequentry, sizeof(startsequentry));
    blockread(outputfile, starttick, sizeof(starttick));
    blockread(outputfile, blocklen, sizeof(blocklen));

    blockread(outputfile, sdecay, sizeof(sdecay));
    blockread(outputfile, trackinfo, sizeof(trackinfo));
    blockread(outputfile, berechnete_sekunden, sizeof(berechnete_sekunden));
    blockread(outputfile, elapsed_time, sizeof(elapsed_time));
    stoppuhr_set(elapsed_time);
    blockread(outputfile, blockcount, sizeof(blockcount));
    blockread(outputfile, outputsize, sizeof(outputsize));

{  writeln (blockcount);halt(0);}
  blockread(outputfile, mem[blklenseg:blklenofs], blockcount * 2);
  blockread(outputfile, mem[blkampseg:blkampofs], blockcount * 6);


  blockread(outputfile, stereo, 1);
  blockread(outputfile, mixfreq, 4);
  blockread(outputfile, _8bit, 1);
  blockread(outputfile, interpol_on, sizeof(interpol_on));
  blockread(outputfile, sdecay_on, sizeof(sdecay_on));
  blockread(outputfile, sdectime, sizeof(sdectime));
  blockread(outputfile, arpsmps, sizeof(arpsmps));

  blockread(outputfile, tickspeedsystem, 1);
  blockread(outputfile, tickspeed, sizeof(tickspeed));
  blockread(outputfile, bpmspeed, sizeof(bpmspeed));

    dmf_checken(dateiname[1]);
    get_pattmem;
    set_up_dmf(dateiname[1]);

    seek(outputfile, 4);
    blockread(outputfile, dwordbuf, 4);
    seek(outputfile, dwordbuf);

    check_freien_platz;
    mask;

    stoppuhr_start;

    for sequentry := startsequentry to sequenzerentries do
      calculate_pattern(sequenzer[sequentry]+1);

    stoppuhr_stop;
    round_up_wav;
    close(inputdmf);
{  for sequentry := 0 to blockcount do begin
    writeln (block_amplify(blockcount)); wait; end;}
    optimize_volume;

    close(outputfile);
  (*********** Berechnung weiterfhren ENDE ****)
  end;

(********* FDW - Datei laden ** ENDE *)
  end
  else
  if do_amplify then
  begin
(******** Amplify - Programm *********)



(******** Amplify - Programm ** ENDE *)
  end
  else
  if do_fadeout then
  begin
(******** Fadeout - Programm *********)



(******** Fadeout - Programm ** ENDE *)
  end;
end;

begin
cls;
parameter_checken;

if not existing (dateiname[1]) then begin
  beep;
  if kein_batchbetrieb then errmsg ('Error:', 'File "'+dateiname[1]+'" not found!');
  abbruch;
end;

if not (continue_fdw or do_amplify or do_fadeout) then
  normal
else
  services;

end.