unit fdw2_rch;
interface
function read_rchan(index:integer):longint; {index: 0 - 15999 }
procedure clear_rchan;
procedure add_rchan(index:integer; wert:longint);
procedure get_rchan_mem;

implementation

uses pattload;

var chseg, chofs:word;
    p: pointer;

function read_rchan(index:integer):longint;
begin
  read_rchan := memL[chseg:chofs+index*4];
end;

procedure clear_rchan;
begin
  fillchar(mem[chseg:chofs], blocklen*4, 0);
end;

procedure add_rchan(index:integer; wert:longint);
begin
  inc(memL[chseg:chofs+index*4], wert);
end;

procedure get_rchan_mem;
begin
  getmem(p, maxblocklen * 4);
  chseg := seg(p^);
  chofs := ofs(p^);
end;

end.