UNIT FDWinput;

INTERFACE
PROCEDURE set_up_dmf(filename:string);
FUNCTION inputdmf16(adresse:longint):INTEGER;
FUNCTION inputdmf8(adresse:longint):SHORTINT;
var inputdmf: file;


IMPLEMENTaTION
var fdwinputMEM: pointer;
bereichstart, bereichende: LONGINT;
to_be_read, dmflaenge: LONGINT;
indmfseg, indmfofs: WORD;

PROCEDURE set_up_dmf(filename:string);
BEGIN
  assign(inputdmf,filename);
  reset(inputdmf,1);
  dmflaenge := filesize(inputdmf);
END;

PROCEDURE reload;
BEGIN
  IF to_be_read > (bereichende-1) THEN
  BEGIN
    bereichstart := to_be_read - 16;
    IF bereichstart < 0 THEN bereichstart := 0;
    bereichende := bereichstart + 32767;
    if bereichende > (dmflaenge-1) then bereichende := (dmflaenge-1);
  END
  ELSE
  BEGIN
    bereichende := to_be_read + 16384;
    IF bereichende > (dmflaenge-1) THEN bereichende := (dmflaenge-1);
    bereichstart := bereichende - 32767;
    if bereichstart < 0 then bereichstart := 0;
  END;
  if bereichende-bereichstart > 0 THEN
  BEGIN
    seek(inputdmf, bereichstart);
    BLOCKREAD(inputdmf, Mem[indmfseg:indmfofs], bereichende-bereichstart+1);
  END;
END;


FUNCTION inputdmf16(adresse:longint):INTEGER;
BEGIN
  IF (adresse > (bereichende-1)) OR (adresse < bereichstart) THEN
  BEGIN
    to_be_read := adresse;
    reload;
  END;
  inputdmf16 := MemW[inDMFseg:inDMFofs + adresse - bereichstart];
END;

FUNCTION inputdmf8(adresse:longint):SHORTINT;
BEGIN
  IF (adresse > bereichende-1) OR (adresse < bereichstart) THEN
  BEGIN
    to_be_read := adresse;
    reload;
  END;
  inputdmf8 := Mem[inDMFseg:inDMFofs + adresse - bereichstart];
END;



BEGIN
getmem(fdwinputMEM,32768);
indmfseg := seg(fdwinputMEM^);
indmfofs := ofs(fdwinputMEM^);
bereichende := -1;

END.