unit fdwparam;

interface
uses dos;

var strbuf: string;
kein_batchbetrieb: BOOLEAN;
do_fadeout: BOOLEAN;
do_amplify: boolean;
continue_fdw: boolean;
sdecay_on : array[1..32] of boolean;
sdectime: longint;
sdecsmps: longint;
interpol_on: array[1..32] of boolean;
dateiname: array[1..2] of pathstr;
fdw_dateiname: pathstr;
mixfreq: longint;
arpsmps: longint;
stereo: boolean;
_8bit: boolean;
startsequentry: word;
starttick: word;


procedure parameter_checken;

implementation

uses crt, fio;

PROCEDURE noparams;
BEGIN

(********* Hier mu noch was anderes reingeschrieben werden ('ne Hilfe ****)

  writeln ('Bitte Parameter angeben!');
  write(chr(7));
  halt(1);
END;


PROCEDURE parameter_checken;
  var i,namcount:byte;
  D: DirStr;
  N: NameStr;
  E: ExtStr;

PROCEDURE handle_param(nr:byte);
PROCEDURE switch_einstellen;
var i:byte;
valstr: string[20];
num: byte;
err: integer;

BEGIN
  for i := 1 to ORD(strbuf[0]) do
    strbuf[i] := upcase(strbuf[i]);

  IF (strbuf[2]+strbuf[3]+strbuf[4]+strbuf[5]
     +strbuf[6]+strbuf[7]+strbuf[8] = 'SDECOFF')
      AND ((strbuf[9] = '=') OR (strbuf[9] = ':')) THEN
    BEGIN

(************ SDECOFF - Parameter **************)
      IF (strbuf[10]+strbuf[11]+strbuf[12] = 'ALL') THEN
        for i := 1 to 32 do
          sdecay_on[i] := FALSE
      ELSE
      BEGIN
        strbuf := strbuf + ';';
        valstr := '';
        for i := 10 to ORD(strbuf[0]) do
        begin
          if (strbuf[i] = ',') OR (strbuf[i] = ';')
          then begin
            val(valstr,num,err);
            valstr := '';
            if (num > 0) and (num < 33) THEN sdecay_on[num] := FALSE
          end
          else
            valstr := valstr + strbuf[i];
        end;
      END;
(************* SDECOFF - Ende **************)

    END
  ELSE
  IF (strbuf[2] = 'C') AND ((strbuf[3] = '=') OR (strbuf[3] = ':')) THEN
    BEGIN

(************* C(ontinue) - Parameter *********)
    if not do_fadeout then begin
      continue_fdw := TRUE;
      dateiname[1] := '';
      for i := 4 to ord(strbuf[0]) do
        dateiname[1] := dateiname[1] + strbuf[i];

      FSplit(dateiname[1], D, N, E);
      if N = '' then
        noparams;
      if E = '' then
        E := '.FDW';
      dateiname[1] := D + N + E;
    end;
(************* C(ontinue) - Ende ***************)

    END
  ELSE
  IF (strbuf[2]+strbuf[3]+strbuf[4]+strbuf[5] = 'IOFF')
      AND ((strbuf[6] = '=') OR (strbuf[6] = ':')) THEN
    BEGIN

(************ IOFF - Parameter **************)
      IF (strbuf[7]+strbuf[8]+strbuf[9] = 'ALL') THEN
        for i := 1 to 32 do
          interpol_on[i] := FALSE
      ELSE
      BEGIN
        strbuf := strbuf + ';';
        valstr := '';
        for i := 7 to ORD(strbuf[0]) do
        begin
          if (strbuf[i] = ',') OR (strbuf[i] = ';')
          then begin
            val(valstr,num,err);
            valstr := '';
            if (num > 0) and (num < 33) THEN interpol_on[num] := FALSE
          end
          else
            valstr := valstr + strbuf[i];
        end;
      END;
(************* IOFF - Ende **************)

    END
  ELSE
  IF (strbuf[2]+strbuf[3]+strbuf[4]+strbuf[5]+strbuf[6]
      +strbuf[7]+strbuf[8] = 'FADEOUT')
      AND ((strbuf[9] = '=') OR (strbuf[9] = ':')) THEN
    BEGIN

(************** FADEOUT - Parameter ******)
    if not do_amplify then begin
      do_fadeout := TRUE;
      dateiname[1] := '';
      for i := 10 to ORD(strbuf[0]) do
        dateiname[1] := dateiname[1] + strbuf[i];
      FSplit(dateiname[1], D, N, E);
      if N = '' then
        noparams;
      if E = '' then
        E := '.WAV';
      dateiname[1] := D + N + E;
    end;
(************** FADEOUT - Ende  **********)

    END
  ELSE
  IF (strbuf[2]+strbuf[3]+strbuf[4]+strbuf[5]+strbuf[6]
      +strbuf[7]+strbuf[8] = 'AMPLIFY')
      AND ((strbuf[9] = '=') OR (strbuf[9] = ':')) THEN
    BEGIN

(************** AMPLIFY - Parameter ******)
      do_amplify := TRUE;
      dateiname[1] := '';
      for i := 10 to ORD(strbuf[0]) do
        dateiname[1] := dateiname[1] + strbuf[i];
      FSplit(dateiname[1], D, N, E);
      if N = '' then
        noparams;
      if E = '' then
        E := '.WAV';
      dateiname[1] := D + N + E;
(************** AMPLIFY - Ende ***********)

    END
  ELSE
  IF (strbuf[2]+strbuf[3]+strbuf[4]+strbuf[5]
     +strbuf[6]+strbuf[7]+strbuf[8]+strbuf[9] = 'SDECTIME')
     AND ((strbuf[10] = '=') OR (strbuf[10] = ':'))
  THEN BEGIN

(************** SDECTIME - Parameter ************)
        valstr := '';
        for i := 11 to ORD(strbuf[0]) do begin
          valstr := valstr + strbuf[i];
        end;
        val(valstr, sdectime, err);
(************** SDECTIME - Ende *****************)

  END
  ELSE
  IF (strbuf[2]+strbuf[3] = 'HZ') AND ((strbuf[4] = '=') OR (strbuf[4] = ':'))
  THEN BEGIN

(************** HZ - Parameter ************)
        valstr := '';
        for i := 5 to ORD(strbuf[0]) do begin
          valstr := valstr + strbuf[i];
        end;
        val(valstr, mixfreq, err);
(************** HZ - Ende *****************)

  END
  ELSE
  IF (strbuf = '/BATCH') OR (strbuf = '-BATCH') THEN
    kein_batchbetrieb := FALSE
  ELSE
  IF (strbuf = '/MONO') OR (strbuf = '-MONO') THEN
    stereo := FALSE
  ELSE
  IF (strbuf = '/8BIT') OR (strbuf = '-8BIT') THEN
    _8bit := true;

END;

PROCEDURE dateiname_einstellen;
var i: byte;
BEGIN
  for i := 1 to ORD(strbuf[0]) do
    strbuf[i] := upcase(strbuf[i]);
  inc(namcount);

if namcount < 3 then begin
  dateiname[namcount] := strbuf;

    FSplit(dateiname[namcount], D, N, E);
      if (N = '') and (namcount = 1) then
        noparams;
      if E = '' then
        if namcount = 1 then E := '.DMF' else e := '.WAV';
      dateiname[namcount] := D + N + E;

  if namcount = 1 then begin
    dateiname[2] := dateiname[1];
    FSplit(dateiname[2], D, N, E);
    fdw_dateiname := n+'.FDW';
    e := '.WAV';
    dateiname[2] := N + E;
  end;

end;
END;

BEGIN
  strbuf := paramstr(nr);
  if (strbuf[1] = '/') OR (strbuf[1] = '-') THEN
    switch_einstellen
  else
    if not (continue_fdw or do_amplify or do_fadeout) then
      dateiname_einstellen;
END;

begin
  for i := 1 to 32 do
  begin
    sdecay_on[i] := TRUE;
    interpol_on[i] := TRUE;
  end;
  kein_batchbetrieb := TRUE;
  do_amplify := FALSE;
  do_fadeout := FALSE;
  continue_fdw := FALSE;
  stereo := TRUE;
  mixfreq := 44100;
  sdectime := 50;
  _8bit := false;

  namcount := 0;
  if paramcount > 0 then
    for i := 1 to paramcount do
      handle_param(i);
  if (paramcount < 1) or (dateiname[1] = '') then noparams;

  arpsmps := mixfreq div 80;
  sdecsmps :=  mixfreq div sdectime
end;


END.