unit fdw_disp;

interface

procedure statusline;
procedure mask;
procedure show_free_disk_space;

var free_disk_space: real;

implementation

uses crt,
     dmfcheck,
     fdwparam,
     fio;

procedure headline;
begin
  textlinefill(1,1,' ',0,7,80); textcolor(0); textbackground(7);
  gotoxy(40-26,1); write('Frankus Disk Writer V2.05  by Frank Grtzenbach 1997');
end;

procedure show_free_disk_space;
  var i: byte;
begin
  textbackground(7); textcolor(0);
  gotoxy(69, 25); write(trunc(free_disk_space / 1024), ' KB');
  for i := 1 to 79-wherex do write(' ');
end;

procedure statusline;
begin
  textlinefill(1,25,' ',0,7,80);
  gotoxy(2,25);textcolor(4); write('Esc');
  textcolor (0); write(' Men');
  gotoxy(52,25); write('free disk space:');
  show_free_disk_space;
end;



procedure show_dmfname;
begin
  gotoxy(22, 3); textcolor(11);
  if ord(songname[0]) > 0 then writeln (songname) else writeln('(',dateiname[1],')');
end;

procedure show_wavname;
begin
  gotoxy(22, 5); textcolor(11);
  writeln(dateiname[2]);
end;

procedure mask;
begin
  cls;
  headline;
  statusline;
  textbackground(0);
  textcolor(11); gotoxy(5,3); writeln ('     Source DMF: '); show_dmfname;
  textcolor(11); gotoxy(5,5); writeln ('     Target WAV: '); show_wavname;
end;

end.