unit fdw2_lch;
interface
function read_lchan(index:integer):longint; {index: 0 - 15999 }
procedure clear_lchan;
procedure add_lchan(index:integer; wert:longint);
procedure get_lchan_mem;

implementation

uses pattload;

var chseg, chofs:word;
    p: pointer;

function read_lchan(index:integer):longint;
begin
  read_lchan := memL[chseg:chofs+index*4];
end;

procedure clear_lchan;
begin
  fillchar(mem[chseg:chofs], blocklen*4, 0);
end;

procedure add_lchan(index:integer; wert:longint);
begin
  inc(memL[chseg:chofs+index*4], wert);
end;

procedure get_lchan_mem;
begin
  getmem(p, maxblocklen * 4);
  chseg := seg(p^);
  chofs := ofs(p^);
end;

end.